#!/usr/bin/env pybricks-micropython
from pybricks.hubs import EV3Brick
from pybricks.ev3devices import (Motor, TouchSensor, ColorSensor,
                                 InfraredSensor, UltrasonicSensor, GyroSensor)
from pybricks.parameters import Port, Stop, Direction, Button, Color
from pybricks.tools import wait, StopWatch, DataLog
from pybricks.robotics import DriveBase
from pybricks.media.ev3dev import SoundFile, ImageFile
from pybricks import ev3brick as brick

ev3 = EV3Brick()

l_m = Motor(Port.B, Direction.CLOCKWISE, None)
r_m = Motor(Port.C, Direction.CLOCKWISE, None)
l_s1 = ColorSensor(Port.S1)
l_s2 = ColorSensor(Port.S2)
l_s3 = ColorSensor(Port.S3)
r = DriveBase(l_m, r_m, wheel_diameter=55.5, axle_track=104)
BLACK = 50
RT_L = 100
RT_R = -100
D_S = 150
BD_S = -150
D_R = 10
x = 0

while True:
    if Button.CENTER in brick.buttons():
        wait(20)
        while True:
            if l_s1.color() == Color.WHITE and l_s2.color() == Color.WHITE and l_s3.color() == Color.BLACK:
                r.drive(D_S, 0)
            elif l_s1.color() == Color.WHITE and l_s2.color() == Color.WHITE and l_s3.color() == Color.WHITE:
                r.drive(D_S, 0)
            elif l_s1.color() == Color.BLACK and l_s2.color() == Color.WHITE and l_s3.color() == Color.BLACK:
                r.drive(D_S, 0)
                wait(600)
                while l_s1.color() !=  Color.BLACK:
                    r.drive(0, -200)
                r.stop(Stop.HOLD)
            elif l_s1.color() == Color.BLACK and l_s2.color() == Color.WHITE and l_s3.color() == Color.WHITE:
                r.drive(D_R, -200)
            elif l_s1.color() == Color.WHITE and l_s2.color() == Color.BLACK and l_s3.color() == Color.BLACK:
                r.drive(D_S, 0)
                wait(600)
                while l_s2.color() !=  Color.BLACK:
                    r.drive(0, 200)
                r.stop(Stop.HOLD)
            elif l_s1.color() == Color.WHITE and l_s2.color() == Color.BLACK and l_s3.color() == Color.WHITE:
                r.drive(D_R, 200)
            elif l_s1.color() == Color.BLACK and l_s2.color() == Color.BLACK:
                r.drive(D_S, 0)
                wait(1000)
            elif l_s1.color() == Color.GREEN or l_s2.color() == Color.GREEN:
                r.stop(Stop.COAST)
                wait(30)
            #elif 15 < l_s3.reflection()<25:
                #r.stop(Stop.COAST)
                #wait(300)
                #if 15 < l_s3.reflection()<25 and 15 < l_s1.reflection()<25:
                    #brick.sound.beep(2500, 50, 100)
                    #break
            if l_s1.color() == Color.GREEN or l_s2.color() == Color.GREEN or l_s3.color() == Color.GREEN:
                    brick.sound.beep(150, 50, 100)
                    if l_s1.color() == Color.GREEN and l_s2.color() == Color.GREEN:
                        brick.sound.beep(1500, 50, 100)
                        r.drive(100, 0)
                        wait(2000)
                        r.drive(0, 300)
                        wait(1600)
                        r.stop(Stop.HOLD)
                        while l_s2.color() !=  Color.BLACK:
                            r.drive(0, 300) 
                        r.stop(Stop.HOLD)
                    elif l_s1.color() == Color.GREEN or l_s1.color() == Color.BLUE:
                        r.drive(100, 0)
                        wait(2000)
                        r.drive(0, -300)
                        wait(600)
                        while l_s2.color() !=  Color.BLACK:
                            r.drive(0, -300) 
                        r.stop(Stop.HOLD)
                    elif l_s2.color() == Color.GREEN or l_s2.color() == Color.BLUE:
                        r.drive(100, 0)
                        wait(2000)
                        r.drive(0, 300)
                        wait(600)
                        while l_s1.color() !=  Color.BLACK:
                            r.drive(0, 300) 
                        r.stop(Stop.HOLD)
                    #elif l_s3.color() == Color.GREEN:
                        #x = x + 1
                        #if l_s1.color() == Color.BLACK:
                            #while l_s2.color() != Color.GREEN:
                                #r.drive(0,-200)
                        #elif l_s2.color() == Color.BLACK:
                            #while l_s1.color() != Color.GREEN:
                                #r.drive(0,200)
            elif Button.UP in brick.buttons():
                r.stop(Stop.COAST)
                break